\begin{exercise}{7.1}
  \begin{figure}[h!]
    \centering
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSeven/ex1/bs-scores.pdf}
      \caption{score}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSeven/ex1/bs-epochs.pdf}
      \caption{epochs}
    \end{subfigure}
    
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSeven/ex1/bs-times.pdf}
      \caption{computational time in seconds}
    \end{subfigure}
    \caption{
      different metrics of the SGD learning, for different mini-batch size.
    }
    \label{fig:7.1}
  \end{figure}

  All the runs have the same meta-parameters\footnote{See code for details.}, except for the learning rate that has been chosen proportional to the mini-batch size. The learning rate is constant over all the training, there is no ridge factor or momentum. I've created the train set with 400 samples, and tested all the possible divisors of 400 as mini-batch size.
  
  Results are shown in Figure~\ref{fig:7.1}. The analysis lead us to the conclusion that the optimal batch size is order of 10. Probably using a single simple does not give a faithful estimation the gradient, while using too many of them does not give enough flexibility to the descent and so it fails to adapt to the problem correctly. 
  
  Probably a better tuning of the stopping criteria and meta-parameters can lead us to similar result in term of effectiveness, but having a better performance. I did not tried to optimize in this way since it was out of the scope of the exercise.
  
  \clearpage
  \pythoncode{\RootPathSheetSeven/ex1/code.py}
\end{exercise}